<?php
/*
Plugin Name: NBC UserAdvManager
Version: 2.4.b
Description: Permet de renforcer les possibilits de gestion des utilisateurs.
Plugin URI: http://phpwebgallery.net/ext/extension_view.php?eid=216
Author: Nicco
Author URI: http://gallery-nicco.no-ip.org
*/


/*

 ***** TODO List *****

Liste des choses a faire :

-- fonction commentaire sans valide pour certains users

-- fonction mail non unique que pour certains users

-- partie administration de Confirm Mail
  ++ ajout d'un parametre de delais de possibilit de confirmation
  ++ listing des users en cours de validation
  ++ listing des users expirer et sans avoir valid
  ++ listing des users valid

  ++possibilit de faire des action sur la table :
    demander validation
    forcer confirmation
    nettoyer expir

*/



if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

define('NBC_UserAdvManager_PATH' , PHPWG_PLUGINS_PATH.basename(dirname(__FILE__)).'/');
include_once (NBC_UserAdvManager_PATH.'include/constants.php');
include_once (NBC_UserAdvManager_PATH.'include/functions_UserAdvManager.inc.php');



/* administration du plugin */
add_event_handler('get_admin_plugin_menu_links', 'nbc_UserAdvManager_admin_menu');

function nbc_UserAdvManager_admin_menu($menu)
{
  array_push($menu,
    array(
      'NAME' => 'UserAdvManager',
      'URL'  => get_admin_plugin_menu_link(NBC_UserAdvManager_PATH.'/admin/UserAdvManager_admin.php')
    )
  );

  return $menu;
}



/* creation de user */
add_event_handler('register_user', 'UserAdvManager_Adduser');

function UserAdvManager_Adduser($register_user)
{
  global $conf;
  
  $conf_nbc_UserAdvManager = isset($conf['nbc_UserAdvManager']) ? explode(";" , $conf['nbc_UserAdvManager']) : array();

  if (( isset($conf_nbc_UserAdvManager[0]) and $conf_nbc_UserAdvManager[0] == 'true') or ( isset($conf_nbc_UserAdvManager[4]) and $conf_nbc_UserAdvManager[4] == 'true'))
  {
    $subject = '['.$conf['gallery_title'].'] '.l10n_args(get_l10n_args('Add of %s', $register_user['username']));

    SendMail2User($subject, $register_user['id'], $register_user['username'], $_POST['password'], $register_user['email']);
  }
}



/* suppression de user */
add_event_handler('delete_user', 'UserAdvManager_Deluser');

function UserAdvManager_Deluser($user_id)
{

  DeleteConfirmMail($user_id);

}



add_event_handler('init', 'UserAdvManager_InitPage');
 
function UserAdvManager_InitPage()
{
  global $conf, $template, $page;

  $conf_nbc_UserAdvManager = isset($conf['nbc_UserAdvManager']) ? explode(";" , $conf['nbc_UserAdvManager']) : array();

  include(get_language_filepath('plugin.lang.php', NBC_UserAdvManager_PATH));
  
  
 
/* identification de user */
  if (script_basename() == 'identification')
  {
    if (isset($_POST['login']))
    {
      /* username insensible a la casse */
      if (isset($conf_nbc_UserAdvManager[3]) and $conf_nbc_UserAdvManager[3] == 'true' )
      {
        $new_username =  NotSensibleSearchUsername($_POST['username']);
        $_POST['username'] = $new_username == '' ? $_POST['username'] : $new_username;
      }
    }
  }



/* Admin gestion user */
  if (script_basename() == 'admin' and isset($_GET['page']) and $_GET['page'] == 'user_list')
  {
    if (isset($_POST['submit_add']))
    {
      /* username insensible a la casse */
      if (isset($conf_nbc_UserAdvManager[3]) and $conf_nbc_UserAdvManager[3] == 'true' )
      {
        $new_username =  NotSensibleSearchUsername($_POST['login']);
        $_POST['login'] = $new_username == '' ? $_POST['login'] : $new_username;
      }


      /* nom utilisateur sans caracteres interdits */
      if (isset($conf_nbc_UserAdvManager[9]) and $conf_nbc_UserAdvManager[9] == 'true' and !empty($_POST['login']) and !ValidateUsername($_POST['login']))
      {
        $lang['reg_err_login1'] = l10n('reg_err_login6')."'".$conf_nbc_UserAdvManager[10]."'";
        $_POST['login'] = '';
      }


      /* adresse mail obligatoire */
      if (isset($conf_nbc_UserAdvManager[1]) and $conf_nbc_UserAdvManager[1] == 'true' and empty($_POST['email']))
      {
        $lang['reg_err_mail_address'] = l10n('reg_err_mail_need').'<br>';
        $_POST['email'] = l10n('email_need');
      }



      /* adresse mail unique */
      if (isset($conf_nbc_UserAdvManager[2]) and $conf_nbc_UserAdvManager[2] == 'true' and !empty($_POST['email']) and SearchMail($_POST['email']) > 0)
      {
        $lang['reg_err_mail_address'] = l10n('reg_err_mail_unik');
        $_POST['email'] = l10n('email_unik');
      }
    }
  }



/* creation OU mise a jour de user */
  if (in_array(script_basename(), array('register', 'profile')))
  {
    if (isset($_POST['submit']) or isset($_POST['validate']))
    {
      /* adresse mail obligatoire */
      if (isset($conf_nbc_UserAdvManager[1]) and $conf_nbc_UserAdvManager[1] == 'true' and empty($_POST['mail_address']))
      {
        $lang['reg_err_mail_address'] = l10n('reg_err_mail_need').'<br>';
        $_POST['mail_address'] = l10n('email_need');
      }
    }
  }



/* creation de user */
  if (script_basename() == 'register')
  {
    if (isset($_POST['submit']))
    {
      /* username insensible a la casse */
      if (isset($conf_nbc_UserAdvManager[3]) and $conf_nbc_UserAdvManager[3] == 'true')
      {
        $new_username =  NotSensibleSearchUsername($_POST['login']);
        $_POST['login'] = $new_username == '' ? $_POST['login'] : $new_username;
      }


      /* nom utilisateur sans caracteres interdits */
      if (isset($conf_nbc_UserAdvManager[9]) and $conf_nbc_UserAdvManager[9] == 'true' and !empty($_POST['login']) and !ValidateUsername($_POST['login']))
      {
        $lang['reg_err_login1'] = l10n('reg_err_login6')."'".$conf_nbc_UserAdvManager[10]."'";
        $_POST['login'] = '';
      }


      /* adresse mail unique */
      if (isset($conf_nbc_UserAdvManager[2]) and $conf_nbc_UserAdvManager[2] == 'true' and !empty($_POST['mail_address']) and SearchMail($_POST['mail_address']) > 0)
      {
        $lang['reg_err_mail_address'] = l10n('reg_err_mail_unik');
        $_POST['mail_address'] = l10n('email_unik');
      }
    }
  }



/* mise a jour de user */
  if (script_basename() == 'profile')
  {
    if (isset($_POST['validate']))
    {
      /* adresse mail unique */
      if (isset($conf_nbc_UserAdvManager[2]) and $conf_nbc_UserAdvManager[2] == 'true' and !empty($_POST['mail_address']) and SearchMail($_POST['mail_address']) > 0)
      {
        $lang['reg_err_mail_address'] = l10n('reg_err_mail_unik');
        $_POST['mail_address'] = l10n('email_unik');
      }



      /* envoyer mail user */
      if (( isset($conf_nbc_UserAdvManager[0]) and $conf_nbc_UserAdvManager[0] == 'true') or ( isset($conf_nbc_UserAdvManager[7]) and $conf_nbc_UserAdvManager[7] == 'true'))
      {
        $errors = array();
  
        $int_pattern = '/^\d+$/';
        if (empty($_POST['nb_image_line'])
            or (!preg_match($int_pattern, $_POST['nb_image_line'])))
        {
          $errors[] = l10n('nb_image_line_error');
        }
      
        if (empty($_POST['nb_line_page'])
            or (!preg_match($int_pattern, $_POST['nb_line_page'])))
        {
          $errors[] = l10n('nb_line_page_error');
        }
      
        if ($_POST['maxwidth'] != ''
            and (!preg_match($int_pattern, $_POST['maxwidth'])
                 or $_POST['maxwidth'] < 50))
        {
          $errors[] = l10n('maxwidth_error');
        }
        if ($_POST['maxheight']
             and (!preg_match($int_pattern, $_POST['maxheight'])
                   or $_POST['maxheight'] < 50))
        {
          $errors[] = l10n('maxheight_error');
        }
        // periods must be integer values, they represents number of days
        if (!preg_match($int_pattern, $_POST['recent_period'])
            or $_POST['recent_period'] <= 0)
        {
          $errors[] = l10n('periods_error') ;
        }
      
        if (isset($_POST['mail_address']))
        {
          $mail_error = validate_mail_address($_POST['mail_address']);
          if (!empty($mail_error))
          {
            $errors[] = $mail_error;
          }
        }
      
        if (!empty($_POST['use_new_pwd']))
        {
          // password must be the same as its confirmation
          if ($_POST['use_new_pwd'] != $_POST['passwordConf'])
          {
            $errors[] = l10n('New password confirmation does not correspond');
          }
      
          if ( !defined('IN_ADMIN') )
          {// changing password requires old password
            $query = '
              SELECT '.$conf['user_fields']['password'].' AS password
              FROM '.USERS_TABLE.'
              WHERE '.$conf['user_fields']['id'].' = \''.$_POST['userid'].'\'
            ;';
            list($current_password) = mysql_fetch_row(pwg_query($query));
        
            if ($conf['pass_convert']($_POST['password']) != $current_password)
            {
              $errors[] = l10n('Current password is wrong');
            }
          }
        }
        
        $confirm_mail_need = false;
              
        if (!empty($_POST['mail_address']))
        {
          $query = '
            SELECT '.$conf['user_fields']['email'].' AS email
            FROM '.USERS_TABLE.'
            WHERE '.$conf['user_fields']['id'].' = \''.$_POST['userid'].'\'
          ;';
          list($current_email) = mysql_fetch_row(pwg_query($query));
      
          if ( $_POST['mail_address'] != $current_email and ( isset($conf_nbc_UserAdvManager[7]) and $conf_nbc_UserAdvManager[7] == 'true') )
            $confirm_mail_need = true;
        }

        if (count($errors) == 0 and (( isset($conf_nbc_UserAdvManager[0]) and $conf_nbc_UserAdvManager[0] == 'true') or $confirm_mail_need) )
        {
          $query = '
            SELECT '.$conf['user_fields']['username'].'
            FROM '.USERS_TABLE.'
            WHERE '.$conf['user_fields']['id'].' = \''.$_POST['userid'].'\'
          ;';
          list($username) = mysql_fetch_row(pwg_query($query));


          $subject = '['.$conf['gallery_title'].'] '.l10n_args(get_l10n_args('Update of %s', $username));

          SendMail2User($subject, $_POST['userid'], $username, $_POST['use_new_pwd'], $_POST['mail_address']);
        }
      }
    }
  }
}



add_event_handler('loc_begin_tpl_parse', 'ChangeRegisterProfilePage');

function ChangeRegisterProfilePage()
{
  global $conf, $template;

  $conf_nbc_UserAdvManager = isset($conf['nbc_UserAdvManager']) ? explode(";" , $conf['nbc_UserAdvManager']) : array();

/* creation OU mise a jour de user */
  if (in_array(script_basename(), array('register', 'profile')))
  {
    if (isset($conf_nbc_UserAdvManager[1]) and $conf_nbc_UserAdvManager[1] == 'true' )
    {
      $template->set_filenames( array('register'=>'register.tpl') );

      $template->loadfile('register');

      $template->uncompiled_code['register'] = str_replace('{lang:Mail address}', '* {lang:Mail address}', $template->uncompiled_code['register']);      
    }
  }
}



add_event_handler('user_comment_check', 'UserAdvManager_CheckEmptyCommentAuthor', 50, 2);

function UserAdvManager_CheckEmptyCommentAuthor($comment_action, $comm)
{
  global $infos, $conf, $template;

  $conf_nbc_UserAdvManager = isset($conf['nbc_UserAdvManager']) ? explode(";" , $conf['nbc_UserAdvManager']) : array();

/* creation OU mise a jour de user */
  if (isset($conf_nbc_UserAdvManager[8]) and $conf_nbc_UserAdvManager[8] == 'true' and $comm['author'] == 'guest')
  {
    $comment_action = 'reject';

    array_push($infos, l10n('UserAdvManager_Empty Author'));
  }

  return $comment_action;
}



?>
